﻿package 
{
	import flash.display.Bitmap;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;

	public class Main2 extends Sprite 
	{
		[Embed(source = "asset/title.png")] private static var title1_png:Class;
		[Embed(source = "asset/start_btn.png")] private static var start_btn_png:Class;
		[Embed(source = "asset/ball.png")] private static var ball_png:Class;
		[Embed(source = "asset/text1.png")] private static var text1_png:Class;
		[Embed(source = "asset/back_btn.png")] private static var back_btn_png:Class;
		[Embed(source = "asset/result0.png")] private static var result0_png:Class;
		[Embed(source = "asset/result1.png")] private static var result1_png:Class;
		[Embed(source = "asset/result2.png")] private static var result2_png:Class;
		[Embed(source = "asset/result3.png")] private static var result3_png:Class;
		[Embed(source = "asset/result4.png")] private static var result4_png:Class;
		[Embed(source = "asset/result5.png")] private static var result5_png:Class;
		
		private var _state:String = "END";
		private var _startBase:Sprite;
		private var _processBase:Sprite;
		private var _resultBase:Sprite;
		private var _resultItems:Array;
		private var _white:Shape;
		
		public function Main2():void 
		{
			init();
			changeView();
		}
		
		/**
		 * 初期化
		 */
		private function init():void
		{
			//スタート画面の作成
			var title:Bitmap = new title1_png();
			title.x = 258;
			title.y = 88;
			
			//ボタンの作成
			var start_btn:Sprite = new Sprite();
			start_btn.addChild(new start_btn_png());
			start_btn.x = 206;
			start_btn.y = 278;
			start_btn.buttonMode = true;
			start_btn.addEventListener(MouseEvent.CLICK, clickHandler);
			start_btn.addEventListener(MouseEvent.ROLL_OVER, rollOverHandler);
			start_btn.addEventListener(MouseEvent.ROLL_OUT, rollOutHandler);
			
			//表示リストに追加
			_startBase = new Sprite();
			_startBase.addChild(title);
			_startBase.addChild(start_btn);
			addChild(_startBase);
			
			//----------------------------------------------
			//占い中画面の作成
			_processBase = new Sprite();
			
			//テキストの作成
			var text1:Bitmap = new text1_png();
			text1.x = 550 / 2 - text1.width / 2;
			text1.y = 400 / 2 - text1.height / 2;
			
			//表示リストに追加
			_processBase.addChild(text1);
			addChild(_processBase);
			
			//----------------------------------------------
			//結果画面の作成
			_resultBase = new Sprite();
			
			//ボタンの作成
			var back_btn:Sprite = new Sprite();
			back_btn.addChild(new back_btn_png());
			back_btn.x = 206;
			back_btn.y = 278;
			back_btn.buttonMode = true;
			back_btn.addEventListener(MouseEvent.CLICK, clickHandler);
			back_btn.addEventListener(MouseEvent.ROLL_OVER, rollOverHandler);
			back_btn.addEventListener(MouseEvent.ROLL_OUT, rollOutHandler);
			
			//結果の作成
			var result0:Bitmap = new result0_png();
			var result1:Bitmap = new result1_png();
			var result2:Bitmap = new result2_png();
			var result3:Bitmap = new result3_png();
			var result4:Bitmap = new result4_png();
			var result5:Bitmap = new result5_png();
			
			//結果を配列に格納する
			_resultItems = [result0, result1, result2, result3, result4, result5];
			var y_array:Array = [110, 110, 110, 147, 147, 110];
			for (var i:int = 0; i < _resultItems.length; i++) {
				var item:Bitmap = _resultItems[i];
				item.x = 550 / 2 - item.width / 2;
				item.y = y_array[i];
				_resultBase.addChild(item);
			}
			
			//表示リストに追加
			_resultBase.addChild(back_btn);
			addChild(_resultBase);
			
			//カバーの作成
			_white = new Shape();
			_white.graphics.beginFill(0xffffff, 1);
			_white.graphics.drawRect(0, 0, 550, 400);
			_white.graphics.endFill();
			addChild(_white);
		}
		
		/**
		 * ボタンのロールオーバー時の処理
		 */
		private function rollOverHandler(e:MouseEvent):void 
		{
			e.target.alpha = 0.8;
		}
		
		/**
		 * ボタンのロールアウト時の処理
		 */
		private function rollOutHandler(e:MouseEvent):void 
		{
			e.target.alpha = 1;
		}
		
		/**
		 * ボタンがクリックされたときの処理
		 */
		private function clickHandler(e:MouseEvent):void 
		{
			changeView();
		}
		
		/**
		 * 表示を変える関数
		 */
		private function changeView():void
		{
			//一旦非表示にする
			_startBase.visible = false;
			_processBase.visible = false;
			_resultBase.visible = false;
			
			//目的の画面を表示する
			if (_state == "END")
			{
				viewStart();
				_state = "START";
			}
			else if (_state == "START")
			{
				viewProcess();
				_state = "PROCESS";
			}
			else if (_state == "PROCESS")
			{
				viewResult();
				_state = "END";
			}
			
			_white.alpha = 1;
			showCover(false);
		}
		
		/**
		 * スタート画面の表示
		 */
		private function viewStart():void
		{
			_startBase.visible = true;
		}
		
		/**
		 * 占い中画面の表示
		 */
		private function viewProcess():void
		{
			_processBase.visible = true;
			Util.timer(showCover, this, true, 3);
			Util.timer(changeView, this, null, 4.5);
		}
		
		/**
		 * 結果画面の表示
		 */
		private function viewResult():void
		{
			_resultBase.visible = true;
			
			//全結果を初期化
			for (var i:int = 0; i < _resultItems.length; i++) {
				_resultItems[i].visible = false;
			}
			
			//ランダムな値を生成
			var r:uint = Math.floor(Math.random() * 5);
			
			//特定の結果を表示
			_resultItems[r].visible = true;
		}
		
		/**
		 * カバーの表示切り替え
		 */
		private function showCover(flag:Boolean):void
		{
			var d:Number = flag? 0.04 : -0.04;
			addEventListener(Event.ENTER_FRAME, loop);
			function loop(e:Event):void {
				_white.alpha += d;
				if (flag && _white.alpha>0.99) {
					_white.alpha = 1;
					removeEventListener(Event.ENTER_FRAME, loop);
				}
				if (!flag && _white.alpha<0.01) {
					_white.alpha = 0;
					removeEventListener(Event.ENTER_FRAME, loop);
				}
			}
		}
	}
}