package  
{
	import com.twitter.api.data.TwitterUser;
	import flash.display.Bitmap;
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import flash.utils.getDefinitionByName;
	/**
	 * ...
	 * @author Katsushi Suzuki
	 */
	public class Card extends MovieClip
	{
		public var id:uint;
		public var user:TwitterUser;
		public var end:Boolean = false;
		private var _back:Bitmap;
		private var _tf:TextField;
		
		/**
		 * コンストラクタ関数
		 */
		public function Card(_user:TwitterUser) 
		{
			user = _user;
			
			createForward();
			createText();
			createIcon();
			createBack();
			setEvent();
			visible = false;
		}
			
		/**
		 * マウスイベントを取得する
		 */
		public function setEvent():void
		{		
			this.buttonMode = true;
			this.addEventListener( MouseEvent.MOUSE_OVER, overHandler );
			this.addEventListener( MouseEvent.MOUSE_OUT, outHandler );
			this.addEventListener( MouseEvent.CLICK, clickHandler );
		}
		
		/**
		 * マウスイベントを取得解除する
		 */
		public function unSetEvent():void
		{
			this.buttonMode = false;
			this.removeEventListener( MouseEvent.MOUSE_OVER, overHandler );
			this.removeEventListener( MouseEvent.MOUSE_OUT, outHandler );
			this.removeEventListener( MouseEvent.CLICK, clickHandler );
		}
		
		/**
		 * カードを複製する
		 */
		public function clone():Card
		{
			return new Card(user);
		}
		
		/**
		 * カードをひっくり返す
		 */
		public function flip():void
		{
			_back.visible = !_back.visible;
		}
		
		/**
		 * 正解時の処理
		 */
		public function win():void
		{
			alpha = 0.5;
			_tf.textColor = 0x777777;
			end = true;
		}
		
		
		
		
		/**
		 * クリック時の処理
		 */
		private function clickHandler(e:MouseEvent):void 
		{
			flip();
			unSetEvent();
			dispatchEvent(new Event("onClick"));
		}
		
		/**
		 * ロールオーバー時の処理
		 */
		private function overHandler(e:MouseEvent):void 
		{
		}
		
		/**
		 * ロールアウト時の処理
		 */
		private function outHandler(e:MouseEvent):void 
		{
		}

		
		
		/**
		 * 表面の生成
		 */
		private function createForward():void
		{
			var c:Class = getDefinitionByName("card_png") as Class;
			var foward:Bitmap = new Bitmap(new c(0, 0), "auto", true);
			addChild(foward);
		}
		
		/**
		 * 裏面の生成
		 */
		private function createBack():void
		{
			var c:Class = getDefinitionByName("card_back_png") as Class;
			_back = new Bitmap(new c(0, 0), "auto", true);
			addChild(_back);
		}
		
		/**
		 * テキストの生成
		 */
		private function createText():void
		{
			_tf = addChild(new TextField())as TextField;
			_tf.selectable = false;
			_tf.mouseEnabled = false;
			_tf.multiline = true;
			_tf.wordWrap = true;
			_tf.width = 90;
			_tf.autoSize = TextFieldAutoSize.LEFT;
			_tf.text = user.screen_name;
			_tf.y = this.height / 2 + 24 -10;
			
			var format:TextFormat = new TextFormat();
			format.font = "_sans";
			format.align = TextFormatAlign.CENTER;
			_tf.setTextFormat(format);
		}
		
		/**
		 * アイコンの生成(読み込み)
		 */
		private function createIcon():void
		{
			var _url:String = user.profile_image_url;
			//PHP経由の場合
			//_url = "php/icon.php?icon_url=" + _user.profile_image_url;
			
			var loader:Loader = addChild(new Loader())as Loader;
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadIconHandler);
			loader.load(new URLRequest(_url));
			addChild(loader);
		}
		
		/**
		 * アイコン読み込み完了時の処理
		 */
		private function loadIconHandler(e:Event):void 
		{
			var icon:Bitmap = Bitmap(e.target.content);
			icon.smoothing = true;
			var w:Number = icon.width;
			icon.scaleX = 48/w;
			icon.scaleY = 48/w;
			icon.x = this.width / 2 - 24;
			icon.y = this.height / 2 - 24 - 10;			
			visible = true;
		}
		
	}

}