package  
{
	import com.twitter.api.data.TwitterUser;
	import com.twitter.api.events.TwitterEvent;
	import com.twitter.api.Twitter;
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.system.ApplicationDomain;
	import flash.system.LoaderContext;
	import flash.text.TextField;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	/**
	 * ...
	 * @author Katsushi Suzuki
	 */
	public class GameView extends MovieClip
	{
		private var _deck:Array = [];
		private var _clickCards:Array = [];
		private var _win_num:uint = 0;
		private var _twitter_id:String = "orangesuzuki";
		
		private var _motion_good:MovieClip;
		private var _motion_miss:MovieClip;
		private var _motion_clear:MovieClip;
		private var asset:Loader;
		
		public function GameView() 
		{
			//素材の読み込み
			var context:LoaderContext = new LoaderContext();  
			context.applicationDomain = ApplicationDomain.currentDomain;
			asset = new Loader();
			asset.contentLoaderInfo.addEventListener(Event.COMPLETE, completeHandler);
			asset.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, errorHandler);
			asset.load(new URLRequest("asset.swf"), context);
			addChild(asset);
			function completeHandler(e:Event):void {
				for (var i:int = 0; i < MovieClip(asset.content).numChildren; i++) 
				{
					var mc:MovieClip = MovieClip(asset.content).getChildAt(i) as MovieClip
					mc.stop();
					mc.visible = false;
				}
				
				Object(asset.content).bg.visible = true;
				Object(asset.content).title.visible = true;
				init();
			}
		}
		
		//初期化
		private function init():void
		{
			if ( loaderInfo.parameters["id"] != null && loaderInfo.parameters["id"] != "") {
				_twitter_id = loaderInfo.parameters["id"];
			}
			createNameField(_twitter_id);
		}
		
		/**
		 * 名前入力フィールドを作成
		 */
		private function createNameField(str:String):void
		{
			var tf:TextField = addChild(new TextField())as TextField;
			tf.type = TextFieldType.INPUT;
			tf.border = true;
			tf.x = 400 - 100;
			tf.y = 300 - 10;
			tf.width = 200;
			tf.height = 24;
			tf.background = true;
			tf.restrict = "0-9a-zA-Z.@!#$%&'*+-/=?^_`{|}~";
			
			var message:MovieClip = Object(asset.content).twitter_txt;
			message.x = 400;
			message.y = 300 - 10 - 30;
			message.visible = true;
			
			var btn:MovieClip = Object(asset.content).twitter_btn;
			btn.x = 400;
			btn.y = 300 + 40;
			btn.buttonMode = true;
			btn.addEventListener(MouseEvent.CLICK, clickHandler);
			btn.addEventListener(MouseEvent.MOUSE_OVER, function(e:MouseEvent):void {
				btn.alpha = 0.8;
			});
			btn.addEventListener(MouseEvent.MOUSE_OUT, function(e:MouseEvent):void {
				btn.alpha = 1;
			});
			btn.visible = true;
			
			var format:TextFormat = new TextFormat();
			format.font = "_sans";
			format.align = TextFormatAlign.CENTER;
			format.size = 16;
			tf.defaultTextFormat = format;
			tf.text = str;
			
			function clickHandler(e:MouseEvent):void
			{
				//空白の場合はキャンセルさせる
				if (tf.text == "") return;
				
				//ツイッターIDを変数に保持させる
				_twitter_id = tf.text;
				
				//入力フィールドを消去
				message.visible = false;
				btn.visible = false;
				tf.visible = false;
				
				//フォロワーのアイコンを取得
				loadIcons();
				
				//正解・不正解の演出を作る
				createMotion();
			}
		}
		
		/**
		 * 正解、不正解のモーション用MCを作成
		 */
		private function createMotion():void
		{
			_motion_good = addChild( Object(asset.content).win_motion) as MovieClip;
			_motion_miss = addChild( Object(asset.content).miss_motion) as MovieClip;
			_motion_clear = addChild( Object(asset.content).clear_motion) as MovieClip;
			_motion_good.gotoAndStop(1);
			_motion_miss.gotoAndStop(1);
			_motion_clear.gotoAndStop(1);
			_motion_good.x = 400;
			_motion_good.y = 260;
			_motion_miss.x = 400;
			_motion_miss.y = 260;
			_motion_clear.x = 400;
			_motion_clear.y = 260;
			_motion_good.visible = false;
			_motion_miss.visible = false;
			_motion_clear.visible = false;
			_motion_good.mouseEnabled = false;
			_motion_miss.mouseEnabled = false;
			_motion_clear.mouseEnabled = false;
		}
		
		/**
		 * フォロワーのアイコンを取得
		 */
		private function loadIcons():void
		{
			var base:Sprite = addChild(new Sprite()) as Sprite;
			base.x = 60;
			base.y = 60;
			
			var loading:MovieClip = Object(asset.content).loading_mc;
			loading.x = 400;
			loading.y = 300;
			loading.visible = true;
			loading.play();
			
			var t:Twitter = new Twitter();
			t.addEventListener(TwitterEvent.ON_FRIENDS_RESULT, completeHandler);
			t.addEventListener(TwitterEvent.ON_ERROR, errorHandler);
			t.loadFriends( _twitter_id, false, 0);
			
			function completeHandler(e:TwitterEvent):void
			{
				var users:Array = e.data as Array;
				Util.getShuffleArray(users);
				
				var len:uint = Math.min(10, users.length);
				for (var i:int = 0; i < len; i++)
				{	
					var user:TwitterUser = users[i];
					
					//カードの生成
					var _card:Card = base.addChild(new Card(user)) as Card;
					var _card2:Card = base.addChild(_card.clone()) as Card;
					
					//IDを振る
					_card.id = i;
					_card2.id = i;
					
					//デッキに格納
					_deck.push( _card );
					_deck.push( _card2 );
				}
				
				//シャッフル
				Util.getShuffleArray(_deck);
				
				//配置
				for (var j:uint=0; j < _deck.length; j++) {
					_card = _deck[j];
					_card.x = 100 * (j % 7);
					_card.y = 155 * Math.floor(j / 7);
					_card.addEventListener("onClick", onClickHandler);
				}
				
				//ローディングを非表示にする
				loading.stop();
				loading.visible = false;
			}
			
		}
		
		/**
		 * カードクリック時の処理
		 */
		private function onClickHandler(e:Event):void 
		{
			//めくったカードを配列に入れる
			_clickCards.push(e.target);
			
			//2枚めくったとき
			if ( _clickCards.length == 2) {
				judge();
			}
		}
		
		/**
		 * ゲームの判定処理
		 */
		private function judge():void
		{	
			//正解
			if ( _clickCards[0].id == _clickCards[1].id ) {
				
				//正解ポイントを追加
				_win_num += 2;
				
				//通常正解
				if (_win_num < _deck.length-1) win();
					
				//全問正解
				else allClear();
			}
			//ミス
			else {
				lose();
			}
		}
		
		/**
		 * 正解の処理
		 */
		private function win():void
		{
			_clickCards[0].win();
			_clickCards[1].win();
			_motion_miss.visible = false;
			_motion_good.visible = true;
			_motion_good.gotoAndPlay(2);
			unTouchCards();
			Util.timer(initCards, this, null, 0.5);
		}
		
		/**
		 * 不正解の処理
		 */
		private function lose():void
		{	
			_motion_good.visible = false;
			_motion_miss.visible = true;
			_motion_miss.gotoAndPlay(2);
			unTouchCards();
			Util.timer(initCards, this, null, 1);
		}
		
		/**
		 * 全問正解の処理
		 */
		private function allClear():void
		{
			_clickCards[0].win();
			_clickCards[1].win();
			_motion_clear.visible = true;
			_motion_clear.gotoAndPlay(2);
		}
		
		
		/**
		 * カードをクリック不可にする
		 */
		private function unTouchCards():void
		{
			for (var i:uint = 0; i < _deck.length; i++) {
				var _card:Card = _deck[i];
				_card.unSetEvent();
			}
		}
		
		/**
		 * カードをクリック可能にする
		 */
		private function initCards():void
		{			
			for (var i:int = 0; i < _clickCards.length; i++) {
				var _card:Card = _clickCards[i];
				if (!_card.end ) _card.flip();
			}
			_clickCards = [];
			
			for (i = 0; i < _deck.length; i++) {
				_card = _deck[i];
				if (!_card.end ) _card.setEvent();
			}
			_motion_miss.visible = false;
		}
		
		/**
		 * エラー時の処理
		 */
		private function errorHandler(e:IOErrorEvent):void 
		{
		}
	}

}